/**
 **	File ......... BlackAdder.h
 **	Published ....  2004-05-17
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _BLACKADDER_H
#define _BLACKADDER_H

#include <list>

	typedef std::vector<std::string> string_v;
	typedef std::map<std::string,std::string> strstr_m;


typedef struct
{
	std::string name; // classname
	std::string group_name;
	std::string m_namespace;
	std::string filename;
	int line;
	bool bExtern;
	bool bUsed;
	string_v bases; // basklasser
	string_v using_type;
	std::string color;
} CLS;


	typedef std::map<std::string,std::vector<std::string> > typedef_m;

typedef struct
{
	std::string name; // space
	std::vector<CLS *> added; // klasser
	typedef_m typedefs;
} NSP;



class BlackAdder
{
public:
	BlackAdder();
	~BlackAdder();

	CLS *add_class(const std::string& ,string_v& ,const std::string& ,int,bool);
	NSP *GetNamespace(const std::string& name,bool add = true);
	void MakeDot(const std::string& group_name = "");
	void add_using(const std::string& );
	void clear_using();
	void add_type(CLS *,const std::string& );
	void set_typedef(const std::string& nspace,const std::string& ,std::vector<std::string>&);
	bool type_lookup(CLS *,const std::string& typ,string_v&,NSP *&);
	bool is_class(const std::string& nspace,const std::string& name);

private:
	void fix_class();
	CLS *find_class(const std::string& ,const std::string& );
	bool locate(NSP *base,const char *,NSP *&,CLS *&,bool add = true);
	bool has_subclass(NSP *nsp0, CLS *cls0, const std::string& color);
	std::list<CLS *> find_base(NSP *nsp, CLS *cls);
	void find_color(NSP *nsp, CLS *cls);
	CLS *find_class(const std::string& name0);
	//
	std::vector<NSP *> m_added; // namespaces
	strstr_m m_using;
//	typedef_m m_typedef;
};


#endif // _BLACKADDER_H
